commit 071e55e99cf8e5310ec5c0d7815560b33358a311
Author: freddy77 <freddy77>
Date:   Sat Jun 19 09:51:35 2010 +0000

    enable defer by default, tests work correctly, use prepexec for performance

diff --git a/ChangeLog b/ChangeLog
index 18ceb91..e13f077 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Sat Jun 19 11:51:23 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/odbc/odbc.c src/tds/query.c src/tds/token.c:
+	- enable defer by default, tests work correctly, use prepexec for
+	  performance
+
 Sat Jun 19 09:53:14 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/pool/member.c src/tds/unittests/common.c: fix possible core
 
@@ -2480,4 +2485,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3031 2010/06/19 07:53:21 freddy77 Exp $
+$Id: ChangeLog,v 1.3032 2010/06/19 09:51:35 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 930e60a..c148806 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.335 2010/04/10 14:29:36 freddy77 Exp $ */
+/* $Id: tds.h,v 1.336 2010/06/19 09:51:36 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1500,6 +1500,7 @@ int tds_submit_query_params(TDSSOCKET * tds, const char *query, TDSPARAMINFO * p
 int tds_submit_queryf(TDSSOCKET * tds, const char *queryf, ...);
 int tds_submit_prepare(TDSSOCKET * tds, const char *query, const char *id, TDSDYNAMIC ** dyn_out, TDSPARAMINFO * params);
 int tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params);
+int tds8_submit_prepexec(TDSSOCKET * tds, const char *query, const char *id, TDSDYNAMIC ** dyn_out, TDSPARAMINFO * params);
 int tds_submit_execute(TDSSOCKET * tds, TDSDYNAMIC * dyn);
 int tds_send_cancel(TDSSOCKET * tds);
 const char *tds_next_placeholder(const char *start);
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 643a571..4a22069 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.533 2010/06/18 19:48:56 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.534 2010/06/19 09:51:36 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -88,9 +88,7 @@ static void odbc_col_setname(TDS_STMT * stmt, int colpos, const char *name);
 static SQLRETURN odbc_stat_execute(TDS_STMT * stmt, const char *begin, int nparams, ...);
 static SQLRETURN odbc_free_dynamic(TDS_STMT * stmt);
 static SQLRETURN odbc_free_cursor(TDS_STMT * stmt);
-#ifdef ENABLE_DEVELOPING
 static SQLRETURN odbc_update_ird(TDS_STMT *stmt, TDS_ERRS *errs);
-#endif
 static SQLRETURN odbc_prepare(TDS_STMT *stmt);
 static SQLSMALLINT odbc_swap_datetime_sql_type(SQLSMALLINT sql_type);
 static int odbc_process_tokens(TDS_STMT * stmt, unsigned flag);
@@ -409,7 +407,6 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 	ODBC_RETURN(dbc, SQL_SUCCESS);
 }
 
-#ifdef ENABLE_DEVELOPING
 static SQLRETURN
 odbc_update_ird(TDS_STMT *stmt, TDS_ERRS *errs)
 {
@@ -440,7 +437,6 @@ odbc_update_ird(TDS_STMT *stmt, TDS_ERRS *errs)
 
 	return odbc_prepare(stmt);
 }
-#endif
 
 static SQLRETURN
 odbc_prepare(TDS_STMT *stmt)
@@ -1298,16 +1294,12 @@ SQLGetEnvAttr(SQLHENV henv, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER B
 
 #endif
 
-#ifdef ENABLE_DEVELOPING
 #define IRD_UPDATE(desc, errs, exit) \
 	do { \
 		if (desc->type == DESC_IRD && ((TDS_STMT*)desc->parent)->need_reprepare && \
 		    odbc_update_ird((TDS_STMT*)desc->parent, errs) != SQL_SUCCESS) \
 			exit; \
 	} while(0)
-#else
-#define IRD_UPDATE(desc, errs, exit) do { } while(0)
-#endif
 
 static SQLRETURN
 _SQLBindParameter(SQLHSTMT hstmt, SQLUSMALLINT ipar, SQLSMALLINT fParamType, SQLSMALLINT fCType, SQLSMALLINT fSqlType,
@@ -3262,6 +3254,13 @@ _SQLExecute(TDS_STMT * stmt)
 			if (ret == TDS_SUCCEED)
 				ret = tds_multiple_done(tds, &multiple);
 		}
+	} else if (stmt->num_param_rows <= 1 && IS_TDS71_PLUS(tds) && (!stmt->dyn || stmt->need_reprepare)) {
+			if (stmt->dyn) {
+				if (odbc_free_dynamic(stmt) != SQL_SUCCESS)
+					ODBC_RETURN(stmt, SQL_ERROR);
+			}
+			stmt->need_reprepare = 0;
+			ret = tds8_submit_prepexec(tds, stmt->prepared_query, NULL, &stmt->dyn, stmt->params);
 	} else {
 		/* TODO cursor change way of calling */
 		/* SQLPrepare */
@@ -4421,9 +4420,6 @@ SQLPrepare(SQLHSTMT hstmt, SQLCHAR FAR * szSqlStr, SQLINTEGER cbSqlStr)
 		 && (stmt->attr.cursor_type == SQL_CURSOR_FORWARD_ONLY && stmt->attr.concurrency == SQL_CONCUR_READ_ONLY)) {
 
 		TDSSOCKET *tds = stmt->dbc->tds_socket;
-#ifndef ENABLE_DEVELOPING
-		TDSPARAMINFO *params = NULL;
-#endif
 
 		tds_free_param_results(stmt->params);
 		stmt->params = NULL;
@@ -4436,31 +4432,8 @@ SQLPrepare(SQLHSTMT hstmt, SQLCHAR FAR * szSqlStr, SQLINTEGER cbSqlStr)
 		 * prepare sepatarely so this is not an issue
 		 */
 		if (IS_TDS7_PLUS(tds)) {
-#ifdef ENABLE_DEVELOPING
 			stmt->need_reprepare = 1;
 			ODBC_RETURN_(stmt);
-#else
-			SQLRETURN res;
-
-			/* use current parameter informations if availables */
-			res = start_parse_prepared_query(stmt, 0);
-			if (res != SQL_SUCCESS) {
-				/*
-				 * not all parameters are bounded, prepare
-				 * with dummy parameters however we need to
-				 * prepare again later
-				 * TODO prepare only getting information
-				 */
-				stmt->need_reprepare = 1;
-			} else {
-				params = stmt->params;
-			}
-			/*
-			 * we can't reuse parsed parameters cause we didn't
-			 * compute row for execute
-			 */
-			stmt->param_num = 0;
-#endif
 		}
 
 		tdsdump_log(TDS_DBG_INFO1, "Creating prepared statement\n");
diff --git a/src/tds/query.c b/src/tds/query.c
index 4dd1d18..1114416 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.243 2009/12/13 10:37:37 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.244 2010/06/19 09:51:36 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -1272,6 +1272,112 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 }
 
 /**
+ * tds8_submit_prepexec() creates a temporary stored procedure in the server.
+ * \param tds     state information for the socket and the TDS protocol
+ * \param query   language query with given placeholders (?)
+ * \param id      string to identify the dynamic query. Pass NULL for automatic generation.
+ * \param dyn_out will receive allocated TDSDYNAMIC*. Any older allocated dynamic won't be freed, Can be NULL.
+ * \param params  parameters to use. It can be NULL even if parameters are present. Used only for TDS7+
+ * \return TDS_FAIL or TDS_SUCCEED
+ */
+int
+tds8_submit_prepexec(TDSSOCKET * tds, const char *query, const char *id, TDSDYNAMIC ** dyn_out, TDSPARAMINFO * params)
+{
+	int query_len;
+	int rc;
+	TDSDYNAMIC *dyn;
+	size_t definition_len = 0;
+	char *param_definition = NULL;
+	size_t converted_query_len;
+	const char *converted_query;
+
+	CHECK_TDS_EXTRA(tds);
+	if (params)
+		CHECK_PARAMINFO_EXTRA(params);
+
+	if (!query || !IS_TDS7_PLUS(tds))
+		return TDS_FAIL;
+
+	/* allocate a structure for this thing */
+	dyn = tds_alloc_dynamic(tds, id);
+	if (!dyn)
+		return TDS_FAIL;
+
+	tds->cur_dyn = dyn;
+
+	if (dyn_out)
+		*dyn_out = dyn;
+
+	if (tds_set_state(tds, TDS_QUERYING) != TDS_QUERYING)
+		goto failure_nostate;
+
+	query_len = (int)strlen(query);
+
+	converted_query = tds_convert_string(tds, tds->char_convs[client2ucs2], query, query_len, &converted_query_len);
+	if (!converted_query)
+		goto failure;
+
+	param_definition = tds7_build_param_def_from_query(tds, converted_query, converted_query_len, params, &definition_len);
+	if (!param_definition) {
+		tds_convert_string_free(query, converted_query);
+		goto failure;
+	}
+
+	tds->out_flag = TDS_RPC;
+	START_QUERY;
+	/* procedure name */
+	if (IS_TDS71_PLUS(tds)) {
+		tds_put_smallint(tds, -1);
+		tds_put_smallint(tds, TDS_SP_PREPEXEC);
+	} else {
+		tds_put_smallint(tds, 10);
+		TDS_PUT_N_AS_UCS2(tds, "sp_prepexec");
+	}
+	tds_put_smallint(tds, 0);
+
+	/* return param handle (int) */
+	tds_put_byte(tds, 0);
+	tds_put_byte(tds, 1);	/* result */
+	tds_put_byte(tds, SYBINTN);
+	tds_put_byte(tds, 4);
+	tds_put_byte(tds, 0);
+
+	tds7_put_params_definition(tds, param_definition, definition_len);
+	tds7_put_query_params(tds, converted_query, converted_query_len);
+	tds_convert_string_free(query, converted_query);
+	free(param_definition);
+
+	if (params) {
+		int i;
+
+		for (i = 0; i < params->num_cols; i++) {
+			TDSCOLUMN *param = params->columns[i];
+			/* TODO check error */
+			tds_put_data_info(tds, param, 0);
+			/* FIXME handle error */
+			tds_put_data(tds, param);
+		}
+	}
+
+	tds->internal_sp_called = TDS_SP_PREPEXEC;
+
+	rc = tds_query_flush_packet(tds);
+	if (rc != TDS_FAIL)
+		return rc;
+
+failure:
+	/* TODO correct if writing fail ?? */
+	tds_set_state(tds, TDS_IDLE);
+
+failure_nostate:
+	tds->cur_dyn = NULL;
+	tds_free_dynamic(tds, dyn);
+	if (dyn_out)
+		*dyn_out = NULL;
+	return TDS_FAIL;
+}
+
+/**
  * Get column size for wire
  */
 static size_t
diff --git a/src/tds/token.c b/src/tds/token.c
index 3939428..11a86fd 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.384 2010/05/07 21:11:30 jklowden Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.385 2010/06/19 09:51:36 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -625,7 +625,7 @@ tds_process_tokens(TDSSOCKET *tds, TDS_INT *result_type, int *done_flags, unsign
 						cursor->srv_status &= ~(TDS_CUR_ISTAT_CLOSED|TDS_CUR_ISTAT_OPEN|TDS_CUR_ISTAT_DEALLOC);
 						cursor->srv_status |= cursor->cursor_id ? TDS_CUR_ISTAT_OPEN : TDS_CUR_ISTAT_CLOSED|TDS_CUR_ISTAT_DEALLOC;
 					}
-					if (tds->internal_sp_called == TDS_SP_PREPARE 
+					if ((tds->internal_sp_called == TDS_SP_PREPARE || tds->internal_sp_called == TDS_SP_PREPEXEC)
 					    && tds->cur_dyn && tds->cur_dyn->num_id == 0 && curcol->column_cur_size > 0) {
 						tds->cur_dyn->num_id = *(TDS_INT *) curcol->column_data;
 					}
@@ -740,6 +740,7 @@ tds_process_tokens(TDSSOCKET *tds, TDS_INT *result_type, int *done_flags, unsign
 			switch (tds->internal_sp_called) {
 			case 0: 
 			case TDS_SP_PREPARE: 
+			case TDS_SP_PREPEXEC:
 			case TDS_SP_EXECUTE: 
 			case TDS_SP_UNPREPARE: 
 			case TDS_SP_EXECUTESQL:

